
#include "ContextFreeGrammar.h"
using namespace std;




ContextFreeGrammars::Symbol::Symbol(string Name)
{
    this->Name = Name;
}

ContextFreeGrammars::Symbol::~Symbol()
{
}




ContextFreeGrammars::ProductionApplicationHandler::ProductionApplicationHandler()
{
}

ContextFreeGrammars::ProductionApplicationHandler::~ProductionApplicationHandler()
{
}

void* ContextFreeGrammars::ProductionApplicationHandler::ProductionApplied(std::vector<void*>& subTreeResults)
{
    for(vector<void*>::iterator i = subTreeResults.begin(); i != subTreeResults.end(); i++)
        if(*i != NULL)
            delete *i;
    subTreeResults.clear();
    return NULL;
}



ContextFreeGrammars::Production::Production()
{
    this->handler = NULL;
}

ContextFreeGrammars::Production::~Production()
{
}








ContextFreeGrammars::NonTerminal::NonTerminal(string Name)
    : Symbol(Name)
{
}

ContextFreeGrammars::NonTerminal::~NonTerminal()
{
    for(vector<Production*>::iterator i = productions.begin(); i != productions.end(); i++)
        delete *i;
    productions.clear();
}

void ContextFreeGrammars::NonTerminal::AddOrDeleteProduction(Production* production)
{
    // test if we already have this production
    bool isNew = true;
    for(vector<Production*>::const_iterator p = productions.begin(); isNew && p != productions.end(); p++)
    {
        bool isEqual = production->produced.size() == (*p)->produced.size();
        int q = 0;
        for(vector<Symbol*>::const_iterator ps = (*p)->produced.begin(), ns = production->produced.begin(); isEqual && ps != (*p)->produced.end(); ps++, ns++)
            if(*ps != *ns)
                isEqual = false;

        if(isEqual)
        {
            delete production;
            return;
        }
    }

    productions.push_back(production);
}


