
#ifndef __ALGORITHMAN__LL1PARSER_H
#define __ALGORITHMAN__LL1PARSER_H

#include <iostream>
#include <stack>
#include "ContextFreeGrammar.h"

    namespace ContextFreeGrammars
    {


        template<class token> class LL1ParserGenerator;
        
        
        
        class LL1StackFrame
        {
        public:
            Production* production;
            std::vector<void*> subTreeResults;
            int position;
        };


        
        template<class token> class LL1Parser
        {
        friend class LL1ParserGenerator<token>;
        protected:

            std::stack<LL1StackFrame*> parserStack;
            std::map<NonTerminal*, std::map<Terminal<token>*, Production*> > lookaheadTable;
            NonTerminal* startsymbol;

        public:
            LL1Parser();
            virtual ~LL1Parser();

            bool verbose;
            void* Parse(Tokenizer<token, 1>& tokenizer, std::ostream& messagestream);
            void GenerateCPlusPlusSourceCode(std::ostream& os) const;
        };

    }

#include "LL1Parser.tpp"

#endif
