
#ifndef __ALGORITHMAN__LR0PARSERGENERATOR_H
#define __ALGORITHMAN__LR0PARSERGENERATOR_H

#include "ContextFreeGrammar.h"
#include "LRParser.h"

    namespace ContextFreeGrammars
    {

        class LR0Element
        {
        public:
            NonTerminal* nonterminal;
            Production* production;
            int dotPosition;
            LR0Element(NonTerminal *nonterminal, Production *production, int dotPosition);
            
            bool operator==(const LR0Element& x) const;
            bool operator!=(const LR0Element& x) const;
        };

        
        template<class Token> class LR0ParserGenerator
        {

        protected:
            ContextFreeGrammar<Token> cfg;
            void Closure0(std::set<LR0Element*>& I);
            std::set<LR0Element*> Goto0(std::set<LR0Element*>& I, Symbol *X);

            std::vector<std::set<LR0Element*>* > syntaxAnalysisTable;
            int FindSyntaxAnalysisTableRow(std::set<LR0Element*>& state);
        public:
            LR0ParserGenerator(const ContextFreeGrammar<Token>& cfg);
            ~LR0ParserGenerator();

            LRParser<Token>* Generate();
        };

    }

#include "LR0ParserGenerator.tpp"

#endif
